=== modified file 'NEWS'
--- NEWS	2005-10-21 16:51:53 +0000
+++ NEWS	2005-10-23 05:55:04 +0000
@@ -54,6 +54,9 @@
 
     * Merge now has a retcode of 1 when conflicts occur. (Robert Collins)
 
+    * --merge-type weave is now supported for file contents.  Tree-shape
+      changes are still three-way based.  (Martin Pool, Aaron Bentley)
+
   TESTING:
 
     * The 'bzr selftest --pattern' option for has been removed, now 

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-10-23 05:20:47 +0000
+++ bzrlib/merge.py	2005-10-23 05:55:04 +0000
@@ -278,7 +278,9 @@
     if this_dir is None:
         this_dir = '.'
     this_branch = Branch.open_containing(this_dir)[0]
-
+    if show_base and not merge_type is ApplyMerge3:
+        raise BzrCommandError("Show-base is not supported for this merge"
+                              " type. %s" % merge_type)
     merger = Merger(this_branch)
     merger.check_basis(check_clean)
     merger.set_other(other_revision)

=== modified file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-10-23 05:20:47 +0000
+++ bzrlib/selftest/test_merge_core.py	2005-10-23 05:55:04 +0000
@@ -7,7 +7,7 @@
 from bzrlib.selftest import TestCaseInTempDir, TestCase
 from bzrlib.branch import ScratchBranch, Branch
 from bzrlib.errors import (NotBranchError, NotVersionedError,
-                           WorkingTreeNotRevision)
+                           WorkingTreeNotRevision, BzrCommandError)
 from bzrlib.inventory import RootEntry
 import bzrlib.inventory as inventory
 from bzrlib.osutils import file_kind, rename, sha_file
@@ -556,7 +556,11 @@
         merge_type = ApplyMerge3
         base = [None, None]
         other = ("mary", -1)
-        merge(other, base, check_clean=True, merge_type=merge_type, this_dir="original")
+        self.assertRaises(BzrCommandError, merge, other, base, check_clean=True,
+                          merge_type=WeaveMerge, this_dir="original",
+                          show_base=True)
+        merge(other, base, check_clean=True, merge_type=merge_type,
+              this_dir="original")
         self.assertEqual("John\n", open("original/file1", "rt").read())
         self.assertEqual("Mary\n", open("original/file2", "rt").read())
  

